#ifndef gpio_h
#define gpio_h

#include "nrf_drv_gpiote.h"

//*****************************************************************************
//
//! defines for GPIOs.
//
//***************************************************************************** 
#define OUTPUT                             0
#define INPUT                              1
#define HIGH                               1
#define LOW                                0

#define PIN_NOT_USED                       0xFF


typedef enum
{
   PIN_VALID = 0,
   PIN_NOT_VALID,
   PIN_OCCUPIED,
}pin_status;

//*****************************************************************************
//
//! global vaiable.
//
//***************************************************************************** 
extern pin_status pins_status[64];

//*****************************************************************************
//
//! local function pointer.
//! note: don't remove from this postion
//
//***************************************************************************** 
typedef void (*gpiote_inEventHandler)(void);//(nrf_drv_gpiote_pin_t pin, nrf_gpiote_polarity_t action);

//*****************************************************************************
//
//! global functions.
//
//***************************************************************************** 
void gpiote_init(void);
pin_status gpiote_pinMode(uint32_t pinNumber, uint8_t state, nrf_gpiote_polarity_t senseTrnsiton, gpiote_inEventHandler actionEvent);
void gpiote_eventEnable(uint32_t pinNumber);
void gpiote_eventDisable(uint32_t pinNumber);
pin_status gpio_pinMode(uint32_t pinNumber, uint8_t state);
void gpio_write(uint32_t pinNumber, uint8_t value);
bool gpio_read(uint32_t pinNumber);

#endif